"""
This type stub file was generated by pyright.
"""

from typing import Callable, Optional, Tuple, Union
from ._structures import InfinityType, NegativeInfinityType

"""Vendoered from
https://github.com/pypa/packaging/blob/main/packaging/version.py
"""
__all__ = ["parse", "Version", "LegacyVersion", "InvalidVersion", "VERSION_PATTERN"]
InfiniteTypes = Union[InfinityType, NegativeInfinityType]
PrePostDevType = Union[InfiniteTypes, Tuple[str, int]]
SubLocalType = Union[InfiniteTypes, int, str]
LocalType = Union[NegativeInfinityType, Tuple[Union[SubLocalType, Tuple[SubLocalType, str], Tuple[NegativeInfinityType, SubLocalType],], ...,],]
CmpKey = Tuple[int, Tuple[int, ...], PrePostDevType, PrePostDevType, PrePostDevType, LocalType]
LegacyCmpKey = Tuple[int, Tuple[str, ...]]
VersionComparisonMethod = Callable[[Union[CmpKey, LegacyCmpKey], Union[CmpKey, LegacyCmpKey]], bool]
_Version = ...
def parse(version: str) -> Union[LegacyVersion, Version]:
    """Parse the given version from a string to an appropriate class.

    Parameters
    ----------
    version : str
        Version in a string format, eg. "0.9.1" or "1.2.dev0".

    Returns
    -------
    version : :class:`Version` object or a :class:`LegacyVersion` object
        Returned class depends on the given version: if is a valid
        PEP 440 version or a legacy version.
    """
    ...

class InvalidVersion(ValueError):
    """
    An invalid version was found, users should refer to PEP 440.
    """
    ...


class _BaseVersion:
    _key: Union[CmpKey, LegacyCmpKey]
    def __hash__(self) -> int:
        ...
    
    def __lt__(self, other: _BaseVersion) -> bool:
        ...
    
    def __le__(self, other: _BaseVersion) -> bool:
        ...
    
    def __eq__(self, other: object) -> bool:
        ...
    
    def __ge__(self, other: _BaseVersion) -> bool:
        ...
    
    def __gt__(self, other: _BaseVersion) -> bool:
        ...
    
    def __ne__(self, other: object) -> bool:
        ...
    


class LegacyVersion(_BaseVersion):
    def __init__(self, version: str) -> None:
        ...
    
    def __str__(self) -> str:
        ...
    
    def __repr__(self) -> str:
        ...
    
    @property
    def public(self) -> str:
        ...
    
    @property
    def base_version(self) -> str:
        ...
    
    @property
    def epoch(self) -> int:
        ...
    
    @property
    def release(self) -> None:
        ...
    
    @property
    def pre(self) -> None:
        ...
    
    @property
    def post(self) -> None:
        ...
    
    @property
    def dev(self) -> None:
        ...
    
    @property
    def local(self) -> None:
        ...
    
    @property
    def is_prerelease(self) -> bool:
        ...
    
    @property
    def is_postrelease(self) -> bool:
        ...
    
    @property
    def is_devrelease(self) -> bool:
        ...
    


_legacy_version_component_re = ...
_legacy_version_replacement_map = ...
VERSION_PATTERN = ...
class Version(_BaseVersion):
    _regex = ...
    def __init__(self, version: str) -> None:
        ...
    
    def __repr__(self) -> str:
        ...
    
    def __str__(self) -> str:
        ...
    
    @property
    def epoch(self) -> int:
        ...
    
    @property
    def release(self) -> Tuple[int, ...]:
        ...
    
    @property
    def pre(self) -> Optional[Tuple[str, int]]:
        ...
    
    @property
    def post(self) -> Optional[int]:
        ...
    
    @property
    def dev(self) -> Optional[int]:
        ...
    
    @property
    def local(self) -> Optional[str]:
        ...
    
    @property
    def public(self) -> str:
        ...
    
    @property
    def base_version(self) -> str:
        ...
    
    @property
    def is_prerelease(self) -> bool:
        ...
    
    @property
    def is_postrelease(self) -> bool:
        ...
    
    @property
    def is_devrelease(self) -> bool:
        ...
    
    @property
    def major(self) -> int:
        ...
    
    @property
    def minor(self) -> int:
        ...
    
    @property
    def micro(self) -> int:
        ...
    


_local_version_separators = ...
